	.set at
	.set reorder

	.macro global sym
	.globl \sym
	.type \sym, %function
\sym:
	.endm

	.macro globalts sym
	.section .text.\sym, "ax"
	global \sym
	.endm

global start
	# initialize bss
	la $t0, __bss_start
	la $t1, __bss_end
bss_clear:
	beq $t0, $t1, bss_clear_done
	sw $zero, 0($t0)
	addiu $t0,4
	j bss_clear
bss_clear_done:

	la $a0, __bss_end
	li $a1, 0x801Ff000 #stack = 801Ff000..801Ffff0
	subu $a1, $a0
	jal init_heap

	# call main
	jal main

	# main must not return...
die:
	j die

globalts calla0
	move $t1, $a0
	move $a0, $a1
	move $a1, $a2
	move $a2, $a3
	li $t2, 0xa0
	jr $t2

globalts callb0
	move $t1, $a0
	move $a0, $a1
	move $a1, $a2
	move $a2, $a3
	lw $a3, 0x10($sp)
	li $t2, 0xb0
	jr $t2

# $a0 passed as is.
globalts syscall
	syscall 0
	jr $ra

	# override unwind function here to avoid likling libgcc's.
	# -C panic=abort will drop landing-pad that calls _Unwind_Resume but...?
#globalts _Unwind_Resume
#	j .

# target dependent.
# just halt.
globalts abort
	break 0

# not implemented: just break.
globalts posix_memalign
	break 0

#globalts __tls_get_addr
#	jr $ra
globalts pthread_mutex_lock
	jr $ra
globalts pthread_mutex_unlock
	jr $ra
globalts __xpg_strerror_r
	jr $ra
globalts __errno_location
	jr $ra
#globalts pthread_key_create
#	jr $ra
globalts pthread_mutex_destroy
	jr $ra
globalts pthread_cond_destroy
	jr $ra
globalts pthread_rwlock_rdlock
	li $v0, 0
	jr $ra
globalts pthread_rwlock_wrlock
	li $v0, 0
	jr $ra
globalts pthread_rwlock_unlock
	li $v0, 0
	jr $ra
#globalts pthread_getspecific
#	jr $ra
#globalts pthread_setspecific
#	jr $ra
#globalts pthread_key_delete
#	jr $ra
globalts __sync_synchronize
	jr $ra

#	.rdata
#	.align 3
#global test1vb
#	.incbin "JUMP.VB"
